Rokolabs.Library.WebApp/Controllers/CatalogController.cs
using System.Web.Mvc;
using Rokolabs.Library.WebApp.Models.ViewModels;
using Rokolabs.Library.WebApp.Models.BindingModels;
using PagedList;
using Rokolabs.Library.Tools;
using Rokolabs.Library.BLL.Interfaces;
using AutoMapper;
using System.Collections.Generic;
using Rokolabs.Library.Entities;
using System.Linq;

namespace Rokolabs.Library.WebApp.Controllers
{
    public class CatalogController : Controller
    {
        private const int quantityRowsOnPage = 20;
        private ILibraryLogic logic;
        private IAuthorsLogic authorsLogic;
        private IMapper mapper;

        public CatalogController(ILibraryLogic logic, IAuthorsLogic authorsLogic, IMapper mapper)
        {
            this.logic = logic;
            this.authorsLogic = authorsLogic;
            this.mapper = mapper;
        }

        // GET: Catalog
        public ActionResult Index(Page<LibraryEntryVM> page)
        {
            SetViewBagSortBy(page.Sort);
            var pageBM = mapper.Map<Page<LibraryEntryVM>, Page<LibraryEntry>>(page);
            return View(mapper.Map<Page<LibraryEntry>, Page<LibraryEntryVM>>(logic.GetCatalogForPage(pageBM)));
        }

        // GET: Catalog/Details/id
        public ActionResult Details(int? id, string entryType)
        {
            if (User.IsInRole("User"))
            {
                Logger.AddEvent(LogEventType.Warning, "MVC", "CatalogController", "Details", $"User with login \"{User.Identity.Name}\" is attempting retrieve {GetEntryName(entryType)} details");
            }

            var controllerName = GetControllerName(entryType);
            return RedirectToAction("Details", controllerName, new { id });                      
        }

        // GET: Catalog/Delete/id
        public ActionResult Delete(int? id, string entryType)
        {
            if (User.IsInRole("User"))
            {
                Logger.AddEvent(LogEventType.Warning, "MVC", "CatalogController", "Delete", $"User with login \"{User.Identity.Name}\" is attempting delete {GetEntryName(entryType)}");
            }

            var controllerName = GetControllerName(entryType);
            return RedirectToAction("Delete", controllerName, new { id });
        }

        // GET: Catalog/Create/
        public ActionResult Create(string entryType)
        {
            if (User.IsInRole("User"))
            {
                Logger.AddEvent(LogEventType.Warning, "MVC", "CatalogController", "Create", $"User with login \"{User.Identity.Name}\" is attempting create {GetEntryName(entryType)}");
            }

            var controllerName = GetControllerName(entryType);
            return RedirectToAction("Create", controllerName);
        }

        // GET: Catalog/Edit/id
        public ActionResult Edit(int? id, string entryType)
        {
            if (User.IsInRole("User"))
            {
                Logger.AddEvent(LogEventType.Warning, "MVC", "CatalogController", "Edit", $"User with login \"{User.Identity.Name}\" is attempting edit {GetEntryName(entryType)}");
            }

            var controllerName = GetControllerName(entryType);
            return RedirectToAction("Edit", controllerName, new { id });
        }        

        private string GetControllerName(string entryType)
        {
            string controllerName = null;

            if (entryType == nameof(BookVM) || entryType == nameof(BookBM))
            {
                controllerName = "Books";
            }
            else if (entryType == nameof(NewspaperVM) || entryType == nameof(NewspaperBM))
            {
                controllerName = "Newspapers";
            }
            else if (entryType == nameof(PatentVM) || entryType == nameof(PatentBM))
            {
                controllerName = "Patents";
            }

            return controllerName;
        }

        private string GetEntryName(string entryType)
        {
            string name = entryType.ToLower();

            if (name.Contains("book"))
            {
                name = "book";
            }
            else if (name.Contains("newspaper"))
            {
                name = "newspaper";
            }
            else if (name.Contains("patent"))
            {
                name = "patent";
            }

            return name;
        }

        private void SetViewBagSortBy(string sort)
        {
            if (sort == "ASC")
            {
                ViewBag.SortBy = new List<SelectListItem> {

                    new SelectListItem
                    {
                        Text = "Descending",
                        Value = "DESC"                        
                    },
                    new SelectListItem
                    {
                        Text = "Ascending",
                        Value = "ASC",
                        Selected = true
                    }
                };
            }
            else
            {
                ViewBag.SortBy = new List<SelectListItem> {

                    new SelectListItem
                    {
                        Text = "Descending",
                        Value = "DESC",
                        Selected = true
                    },
                    new SelectListItem
                    {
                        Text = "Ascending",
                        Value = "ASC"
                    }
                };
            }
        }       
    }
}

Rokolabs.Library.WebApp/Controllers/ServiceController.cs
using Rokolabs.Library.BLL.Interfaces;
using Rokolabs.Library.Entities;
using System.Web.Mvc;
using System.Linq;
using Newtonsoft.Json;
using System.Collections.Generic;
using Rokolabs.Library.WebApp.Models.BindingModels;
using AutoMapper;
using Rokolabs.Library.WebApp.Models.ViewModels;

namespace Rokolabs.Library.WebApp.Controllers
{
    [RoutePrefix("spec")]
    public class ServiceController : Controller
    {
        private INewsapersLogic newspapersLogic;
        private IAuthorsLogic authorsLogic;
        private ICitiesLogic citiesLogic;
        private ICountriesLogic countriesLogic;
        private IMapper mapper;

        public ServiceController(IAuthorsLogic authorsLogic, ICitiesLogic citiesLogic, ICountriesLogic countriesLogic, INewsapersLogic newspapersLogic, IMapper mapper)
        {
            this.authorsLogic = authorsLogic;
            this.citiesLogic = citiesLogic;
            this.countriesLogic = countriesLogic;
            this.newspapersLogic = newspapersLogic;           
            this.mapper = mapper;
        }

        // ***************** CITIES
        [Route("search/city")]
        public ActionResult SearchCities(string name)
        {
            var cities = citiesLogic.GetAllCities();                     

            var query = from city in cities
                        where city.CityName.ToLower().Contains(name.ToLower())
                        select city;

            var json = JsonConvert.SerializeObject(query.ToList().Take(5));

            return Json(json, JsonRequestBehavior.AllowGet); 
        }

        // POST: Spec/AddCity
        [HttpPost]
        [Route("add/city")]
        public ActionResult AddCity(CityBM city)
        {
            if (ModelState.IsValid)
            {
                citiesLogic.AddCity(mapper.Map<City>(city));               
            }

            return new EmptyResult();
        }
        
        [Route("get/city")]
        public ActionResult GetPublicationPlaceForEditedItem()
        {
            var city = TempData["city"] as string;

            if (city != null)
            {
                return Json(city, JsonRequestBehavior.AllowGet);
            }

            return new EmptyResult();
        }

        [ChildActionOnly]
        public ActionResult InsertCityModalDiv()
        {
            return PartialView("_CityModalDiv");
        }

        // ***************** AUTHORS
        [Route("search/authors")]
        public ActionResult SearchAuthors(string name)
        {
            var authors = authorsLogic.GetAllAuthors();
            var authorsVM = mapper.Map<HashSet<AuthorVM>>(authors);

            var query = from author in authorsVM
                        where author.FullName.ToLower().Contains(name.ToLower())
                        select author;

            var json = JsonConvert.SerializeObject(query.ToList().Take(5));

            return Json(json, JsonRequestBehavior.AllowGet);
        }

        // POST: Spec/AddAuthor
        [HttpPost]
        [Route("add/authors")]
        public ActionResult AddAuthor(AuthorBM authorModel)
        {
            if (ModelState.IsValid)
            {
                var author = mapper.Map<Author>(authorModel);
                authorsLogic.AddAuthor(author);
            }

            return new EmptyResult();
        }     

        [Route("get/authors")]
        public ActionResult GetAuthorsForEditedItem()
        {
            HashSet<Author> authors = TempData["authors"] as HashSet<Author>;
            var authorsVM = mapper.Map<HashSet<AuthorVM>>(authors);

            if (authors != null)
            {
                return Json(authorsVM, JsonRequestBehavior.AllowGet);
            }

            return new EmptyResult();
        }

        [ChildActionOnly]
        public ActionResult InsertAuthorModalDiv()
        {
            return PartialView("_AuthorModalDiv");
        }

        // ***************** COUNTRIES
        [Route("search/country")]
        public ActionResult SearchCountries(string name)
        {
            var countries = countriesLogic.GetAllCountries();

            var query = from country in countries
                        where country.CountryName.ToLower().Contains(name.ToLower())
                        select country;

            var json = JsonConvert.SerializeObject(query.Take(5));

            return Json(json, JsonRequestBehavior.AllowGet);
        }

        // POST: Spec/AddCountry
        [HttpPost]
        [Route("add/country")]
        public ActionResult AddCountry(CountryBM country)
        {
            if (ModelState.IsValid)
            {
                countriesLogic.AddCountry(mapper.Map<Country>(country));                        
            }

            return new EmptyResult();
        }

        [Route("get/country")]
        public ActionResult GetCountryForEditedItem()
        {
            var country = TempData["country"] as string;

            if (country != null)
            {
                return Json(country, JsonRequestBehavior.AllowGet);
            }

            return new EmptyResult();
        }

        [ChildActionOnly]
        public ActionResult InsertCountryModalDiv()
        {
            return PartialView("_CountryModalDiv");
        }

        // ***************** NEWSPAPERS
        [Route("search/newspaper")]
        public ActionResult SearchNewspapers(string name)
        {
            var newspapers = newspapersLogic.GetAllNewspapers();

            var query = from newspaper in newspapers
                        where newspaper.Name.ToLower().Contains(name.ToLower())
                        select newspaper;

            var json = JsonConvert.SerializeObject(query.Take(5));

            return Json(json, JsonRequestBehavior.AllowGet);
        }
    }
}

Rokolabs.Library.WebApp/Views/Newspapers/AddIssue.cshtml
@using Rokolabs.Library.WebApp.Models.BindingModels

@model NewspaperIssueBM

@{
    ViewBag.Title = "Add Issue for newspaper";
}

<h2>Add Issue for newspaper</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">

        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })

        <div class="form-group">
            @Html.LabelFor(model => model.ForNewspaper, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownListFor(model => model.ForNewspaper, new List<SelectListItem> { }, new { @class = "dropdown-menu" })
                @Html.ValidationMessageFor(model => model.ForNewspaper, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.NumberOfPages, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.NumberOfPages, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.NumberOfPages, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.IssueNumber, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.IssueNumber, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.IssueNumber, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.IssueDate, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.IssueDate, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.IssueDate, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-0 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" /> |
                @Html.ActionLink("Back to List", "Index", "Catalog")
            </div>
        </div>
    </div>
}

@section Scripts {

    @Scripts.Render("~/bundles/jqueryval")

    @Styles.Render("~/Content/select2.min.css")
    @Scripts.Render("~/Scripts/select2.min.js")

    @Scripts.Render("~/Scripts/dynloaddata.js")

}

Rokolabs.Library.WebApp/Views/Newspapers/Create.cshtml
@using Rokolabs.Library.WebApp.Models.BindingModels

@model NewspaperBM

@{
    ViewBag.Title = "Create a new newspaper";
}

<h2>Create a new newspaper</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>Newspaper</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })

        <div class="form-group">
            @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PublicationYear, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PublicationYear, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PublicationYear, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PublishingHouse, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PublishingHouse, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PublishingHouse, "", new { @class = "text-danger" })
            </div>
        </div>

        @*<div class="form-group">
                @Html.LabelFor(model => model.NumberOfPages, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.NumberOfPages, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.NumberOfPages, "", new { @class = "text-danger" })
                </div>
            </div>*@

        @*Cities*@
        <div class="form-group">
            @Html.LabelFor(model => model.PublicationPlace, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownListFor(model => model.PublicationPlace, new List<SelectListItem> { }, new { @class = "dropdown-menu" })
                @Html.Action("InsertCityModalDiv", "Service")
                @Html.ValidationMessageFor(model => model.PublicationPlace, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Notes, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Notes, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Notes, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ISSN, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ISSN, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ISSN, "", new { @class = "text-danger" })
            </div>
        </div>

        @*<div class="form-group">
                @Html.LabelFor(model => model.IssueNumber, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.IssueNumber, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.IssueNumber, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                @Html.LabelFor(model => model.IssueDate, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.IssueDate, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.IssueDate, "", new { @class = "text-danger" })
                </div>
            </div>*@

        <div class="form-group">
            <div class="col-md-offset-0 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" /> |
                @Html.ActionLink("Back to List", "Index", "Catalog")
            </div>
        </div>
    </div>
}

@section Scripts {

    @Scripts.Render("~/bundles/jqueryval")

    @Styles.Render("~/Content/select2.min.css")
    @Scripts.Render("~/Scripts/select2.min.js")

    @Scripts.Render("~/Scripts/yearval.js") 
    @Scripts.Render("~/Scripts/dynloaddata.js")    
    @Scripts.Render("~/Scripts/addCity.js")
}

Rokolabs.Library.WebApp/Views/Newspapers/Delete.cshtml
@using Rokolabs.Library.WebApp.Models.ViewModels

@model NewspaperVM

@{
    ViewBag.Title = "Delete the newspaper";
}

<h2>Delete the newspaper</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>"@Html.DisplayFor(model => model.Name)"</h4>
    <hr />
    <dl class="dl-horizontal">

        <dt>
            @Html.DisplayNameFor(model => model.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PublicationYear)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PublicationYear)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PublishingHouse)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PublishingHouse)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NumberOfPages)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NumberOfPages)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PublicationPlace)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PublicationPlace)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Notes)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Notes)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ISSN)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ISSN)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.IssueNumber)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.IssueNumber)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.IssueDate)
        </dt>

        <dd>
            @(Model.IssueDate?.ToShortDateString())
        </dd>

    </dl>

    @using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index", "Catalog")
        </div>
    }
</div>

Rokolabs.Library.WebApp/Views/Newspapers/Details.cshtml
@using Rokolabs.Library.WebApp.Models.ViewModels

@model NewspaperVM

@using Rokolabs.Library.Entities

@{
    ViewBag.Title = "Newspaper details";
}

<h2>Newspaper details</h2>

<div style="margin-bottom: 10px; ">
    <h4>"@Html.DisplayFor(model => model.Name)"</h4>
    <hr />
    <dl class="dl-horizontal">

        <dt>
            @Html.DisplayNameFor(model => model.Name)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Name)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PublicationYear)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PublicationYear)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PublishingHouse)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PublishingHouse)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NumberOfPages)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NumberOfPages)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PublicationPlace)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PublicationPlace)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Notes)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Notes)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ISSN)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ISSN)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.IssueNumber)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.IssueNumber)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.IssueDate)
        </dt>

        <dd>
            @(Model.IssueDate?.ToShortDateString())
        </dd>

    </dl>
    <hr />
    <div>
        <span>Another issues:</span>

        @foreach (var item in ViewBag.Issues)
        {
            if (item is Newspaper)
            {
                var newspaper = item as Newspaper;

                if (string.IsNullOrEmpty(newspaper.IssueNumber))
                {
                    continue;
                }

                if (newspaper.IssueNumber == Model.IssueNumber)
                {
                    @Html.Label(Model.IssueNumber)
                    @: |
                }
                else
                {
                    @Html.ActionLink(newspaper.IssueNumber, "Details", new { id = newspaper.EntryId })
                    @: |
                }
            }
        }

    </div>
    <hr />
</div>
<p>
    @Html.ActionLink("Edit", "Edit", new {  id = Model.EntryID }) |
    @Html.ActionLink("Back to List", "Index", "Catalog")
</p>

Rokolabs.Library.WebApp/Views/Newspapers/Edit.cshtml
@model Rokolabs.Library.WebApp.Models.BindingModels.NewspaperBM

@{
    ViewBag.Title = "Edit the newspaper";
}

<h2>Edit the newspaper</h2>

@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>@Html.DisplayFor(model => model.Name)</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            <div class="col-md-10">
                @Html.HiddenFor(model => model.EntryID, new { htmlAttributes = new { @class = "form-control" } })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PublicationYear, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PublicationYear, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PublicationYear, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PublishingHouse, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PublishingHouse, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.PublishingHouse, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.NumberOfPages, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.NumberOfPages, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.NumberOfPages, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PublicationPlace, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownListFor(model => model.PublicationPlace, new List<SelectListItem> { }, new { @class = "dropdown-menu" })
                @Html.Action("InsertCityModalDiv", "Service")
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Notes, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Notes, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Notes, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ISSN, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ISSN, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.ISSN, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.IssueNumber, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.IssueNumber, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.IssueNumber, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.IssueDate, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.IssueDate, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.IssueDate, "", new { @class = "text-danger" })
            </div>
        </div>        

        <div class="form-group">
            <div class="col-md-offset-0 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" /> |
                @Html.ActionLink("Back to List", "Index", "Catalog")
            </div>
        </div>
    </div>
}

@section Scripts {

    @Scripts.Render("~/bundles/jqueryval")

    @Styles.Render("~/Content/select2.min.css")
    @Scripts.Render("~/Scripts/select2.min.js")

    @Scripts.Render("~/Scripts/yearval.js")
    @Scripts.Render("~/Scripts/namesval.js")
    @Scripts.Render("~/Scripts/addCity.js")
    @Scripts.Render("~/Scripts/dynloaddata.js")

}

Rokolabs.Library.WebApp/Views/Newspapers/Index.cshtml
@model IEnumerable<Rokolabs.Library.Entities.Newspaper>

@{
    ViewBag.Title = "Newspapers";
}

<h2>Newspapers</h2>

<p>
    @Html.ActionLink("Create New", "Create") |
    @Html.ActionLink("Add Newspaper Issue", "AddIssue", "Newspapers")
</p>

@Html.Partial("_LibraryEntriesTable", Model)